#!/usr/bin/php -q
<?php

/* Paolo Furieri furieri@ntc.it NETCOM-REG - 30.09.2011 */


$sigla = "NETCOM-REG";
$password = "xxxxxxxx";
$eppserver="epp.nic.it";
$vecchiodns = "dns2.sysnet.it";
$vecchiodns2 = "dns.ntc.it";
$nuovodns = "dns2.sysnet.it";
$nuovoip = "212.102.36.253";
$nuovodns2 = "dns.ntc.it";
$nuovoip2 = "62.48.52.114";

$DEBUG = 1;

// FINE CONFIGURAZIONE; la parte sotto non richiede modifiche


$domain = $argv[1];

if ($domain == "") {
	echo "uso: comando NOMEDOMINIO\n";
	exit;
}

$errore = "";

header("Content-Type: text/plain");

$xml_login='<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<epp xmlns="urn:ietf:params:xml:ns:epp-1.0">
<command>
<login>
<clID>'.$sigla.'</clID>
<pw>'.$password.'</pw>
<options>
<version>1.0</version>
<lang>en</lang>
</options>
<svcs>
<objURI>urn:ietf:params:xml:ns:contact-1.0</objURI>
<objURI>urn:ietf:params:xml:ns:domain-1.0</objURI>
<svcExtension>
<extURI>http://www.nic.it/ITNIC-EPP/extepp-1.0</extURI>
<extURI>http://www.nic.it/ITNIC-EPP/extcon-1.0</extURI>
<extURI>http://www.nic.it/ITNIC-EPP/extdom-1.0</extURI>
<extURI>urn:ietf:params:xml:ns:rgp-1.0</extURI>
</svcExtension>
</svcs>
</login>
</command>
</epp>';

$xml_logout='<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<epp xmlns="urn:ietf:params:xml:ns:epp-1.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="urn:ietf:params:xml:ns:epp-1.0 epp-1.0.xsd">
<command>
<logout/>
<clTRID>xxxxxxx-xxxxxxx</clTRID>
</command>
</epp>';

$xml_updatedns = '<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<epp xmlns="urn:ietf:params:xml:ns:epp-1.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="urn:ietf:params:xml:ns:epp-1.0 epp-1.0.xsd">
<command>
<update>
<domain:update xmlns:domain="urn:ietf:params:xml:ns:domain-1.0" xsi:schemaLocation="urn:ietf:params:xml:ns:domain-1.0 domain-1.0.xsd">
<domain:name>[DOMAIN]</domain:name>
<domain:add>
<domain:ns>
<domain:hostAttr>
<domain:hostName>'.$nuovodns.'</domain:hostName>
<domain:hostAddr ip="v4">'.$nuovoip.'</domain:hostAddr>
</domain:hostAttr>
<domain:hostAttr>
<domain:hostName>'.$nuovodns2.'</domain:hostName>
<domain:hostAddr ip="v4">'.$nuovoip2.'</domain:hostAddr>
</domain:hostAttr>
</domain:ns>
</domain:add>
<domain:rem>
<domain:ns>
<domain:hostAttr>
<domain:hostName>'.$vecchiodns.'</domain:hostName>
</domain:hostAttr>
<domain:hostAttr>
<domain:hostName>'.$vecchiodns2.'</domain:hostName>
</domain:hostAttr>
</domain:ns>
</domain:rem>
</domain:update>
</update>
<clTRID>xxxxxxx-xxxxxxx</clTRID>
</command>
</epp>';

$messaggio = "";

$resp_login = inviaricevi($xml_login);
// cerco il cookie di sessione
$xx = explode('Set-Cookie: ',$resp_login);
$yy = explode(';', $xx[1]);
$epp_SESSIONID = $yy[0];

$xml_updatedns1 = str_replace("[DOMAIN]",$domain,$xml_updatedns);

$resp_updatedns = inviaricevi($xml_updatedns1);

$resp_logout = inviaricevi($xml_logout);

function inviaricevi($xml) {
global $DEBUG;
global $eppsock;
global $inizio, $epp_SESSIONID;
global $eppserver;
$eppsock=fsockopen("ssl://$eppserver",443,$errno,$errstr,60);
$cmd = 
'POST / HTTP/1.1
Host: epp.nic.it
';
if ($epp_SESSIONID) 
 $cmd .= "Cookie: $epp_SESSIONID\r\n";
$cmd .=
'Referer: EPP Client Test
Content-type: application/x-www-form-urlencoded
Content-length: '.strlen($xml).'
Connection: close

' .  $xml;
fputs($eppsock,$cmd);

  $cnt=0;
  $xmlread="";
  while ((!feof($eppsock))&&($cnt<100)){
   $xmlreadslice = fread($eppsock,1024);
   $xmlread.=$xmlreadslice;
   $cnt++;
  }
fclose($eppsock);

if ($DEBUG) {
	$debug = fopen("/var/log/epp_debug.log","a");
	fputs($debug,date("Y-m-d H:i:s:u") ." scritto $cmd\n\n\n");
	fputs($debug,date("Y-m-d H:i:s:u") ." letto $xmlread\n\n\n");
	fclose($debug);
}

return($xmlread);
}

?>
